searchData={"items":[{"type":"module","title":"OPQ","doc":"A simple, in-memory queue with worker pooling and rate limiting in Elixir.","ref":"OPQ.html"},{"type":"function","title":"OPQ.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"OPQ.html#child_spec/1"},{"type":"function","title":"OPQ.enqueue/2","doc":"","ref":"OPQ.html#enqueue/2"},{"type":"function","title":"OPQ.enqueue/4","doc":"","ref":"OPQ.html#enqueue/4"},{"type":"function","title":"OPQ.info/1","doc":"","ref":"OPQ.html#info/1"},{"type":"function","title":"OPQ.init/1","doc":"","ref":"OPQ.html#init/1"},{"type":"function","title":"OPQ.pause/1","doc":"","ref":"OPQ.html#pause/1"},{"type":"function","title":"OPQ.queue/1","doc":"","ref":"OPQ.html#queue/1"},{"type":"function","title":"OPQ.resume/1","doc":"","ref":"OPQ.html#resume/1"},{"type":"function","title":"OPQ.start_link/1","doc":"","ref":"OPQ.html#start_link/1"},{"type":"function","title":"OPQ.stop/1","doc":"","ref":"OPQ.html#stop/1"},{"type":"module","title":"OPQ.Feeder","doc":"A GenStage producer that feeds items in a buffered queue to the consumers.","ref":"OPQ.Feeder.html"},{"type":"function","title":"OPQ.Feeder.handle_call/3","doc":"","ref":"OPQ.Feeder.html#handle_call/3"},{"type":"function","title":"OPQ.Feeder.handle_cast/2","doc":"","ref":"OPQ.Feeder.html#handle_cast/2"},{"type":"function","title":"OPQ.Feeder.handle_demand/2","doc":"","ref":"OPQ.Feeder.html#handle_demand/2"},{"type":"function","title":"OPQ.Feeder.init/1","doc":"","ref":"OPQ.Feeder.html#init/1"},{"type":"function","title":"OPQ.Feeder.start_link/1","doc":"","ref":"OPQ.Feeder.html#start_link/1"},{"type":"module","title":"OPQ.Options","doc":"Options for configuring OPQ.","ref":"OPQ.Options.html"},{"type":"function","title":"OPQ.Options.assign_defaults/1","doc":"","ref":"OPQ.Options.html#assign_defaults/1"},{"type":"function","title":"Examples - OPQ.Options.assign_defaults/1","doc":"iex> Options.assign_defaults([]) |> Keyword.get(:workers)\n    10\n\n    iex> Options.assign_defaults([workers: 4]) |> Keyword.get(:workers)\n    4","ref":"OPQ.Options.html#assign_defaults/1-examples"},{"type":"module","title":"OPQ.OptionsHandler","doc":"Saves and loads options to pass around.","ref":"OPQ.OptionsHandler.html"},{"type":"function","title":"OPQ.OptionsHandler.save_opts/2","doc":"","ref":"OPQ.OptionsHandler.html#save_opts/2"},{"type":"function","title":"OPQ.OptionsHandler.stop/1","doc":"","ref":"OPQ.OptionsHandler.html#stop/1"},{"type":"function","title":"OPQ.OptionsHandler.timeout/1","doc":"","ref":"OPQ.OptionsHandler.html#timeout/1"},{"type":"module","title":"OPQ.Queue","doc":"A `:queue` wrapper so that protocols like `Enumerable` can be implemented.","ref":"OPQ.Queue.html"},{"type":"opaque","title":"OPQ.Queue.t/0","doc":"","ref":"OPQ.Queue.html#t:t/0"},{"type":"module","title":"OPQ.RateLimiter","doc":"Provides rate limit.","ref":"OPQ.RateLimiter.html"},{"type":"function","title":"OPQ.RateLimiter.handle_events/3","doc":"","ref":"OPQ.RateLimiter.html#handle_events/3"},{"type":"function","title":"OPQ.RateLimiter.handle_info/2","doc":"","ref":"OPQ.RateLimiter.html#handle_info/2"},{"type":"function","title":"OPQ.RateLimiter.handle_subscribe/4","doc":"","ref":"OPQ.RateLimiter.html#handle_subscribe/4"},{"type":"function","title":"OPQ.RateLimiter.init/1","doc":"","ref":"OPQ.RateLimiter.html#init/1"},{"type":"function","title":"OPQ.RateLimiter.start_link/1","doc":"","ref":"OPQ.RateLimiter.html#start_link/1"},{"type":"module","title":"OPQ.Worker","doc":"A default worker that simply executes an item if it's a function.","ref":"OPQ.Worker.html"},{"type":"function","title":"OPQ.Worker.start_link/1","doc":"","ref":"OPQ.Worker.html#start_link/1"},{"type":"module","title":"OPQ.WorkerSupervisor","doc":"A supervisor that subscribes to `Feeder` and spins up the worker pool.","ref":"OPQ.WorkerSupervisor.html"},{"type":"function","title":"OPQ.WorkerSupervisor.start_link/1","doc":"","ref":"OPQ.WorkerSupervisor.html#start_link/1"},{"type":"extras","title":"Changelog","doc":"# OPQ Changelog","ref":"changelog.html"},{"type":"extras","title":"master - Changelog","doc":"","ref":"changelog.html#master"},{"type":"extras","title":"v4.0.4 [2023-09-29] - Changelog","doc":"- [Improved] Updated all the dependencies\n- [Improved] Varies small fixes and improvements","ref":"changelog.html#v4-0-4-2023-09-29"},{"type":"extras","title":"v4.0.3 [2023-07-02] - Changelog","doc":"- [Added] Graceful handling of exit signals in the default worker","ref":"changelog.html#v4-0-3-2023-07-02"},{"type":"extras","title":"v4.0.2 [2023-06-13] - Changelog","doc":"- [Improved] Updated all the dependencies","ref":"changelog.html#v4-0-2-2023-06-13"},{"type":"extras","title":"v4.0.1 [2021-10-14] - Changelog","doc":"- [Fixed] Wrong link to the project","ref":"changelog.html#v4-0-1-2021-10-14"},{"type":"extras","title":"v4.0.0 [2021-10-14] - Changelog","doc":"- [Added] `OPQ.Queue` wraps `:queue` and implements `Enumerable`","ref":"changelog.html#v4-0-0-2021-10-14"},{"type":"extras","title":"v3.3.0 [2021-10-12] - Changelog","doc":"- [Added] The ability to start as part of a supervision tree","ref":"changelog.html#v3-3-0-2021-10-12"},{"type":"extras","title":"v3.2.0 [2021-10-11] - Changelog","doc":"- [Improved] Updated to the new `ConsumerSupervisor` syntax\n- [Improved] Updated all the dependencies","ref":"changelog.html#v3-2-0-2021-10-11"},{"type":"extras","title":"v3.1.1 [2018-10-15] - Changelog","doc":"- [Fixed] Infinite loop without rate limiting (thanks @Harrisonl)","ref":"changelog.html#v3-1-1-2018-10-15"},{"type":"extras","title":"v3.1.0 [2018-07-30] - Changelog","doc":"- [Improved] Varies small fixes and improvements\n- [Improved] Use `cast` instead of `call` to avoid timeouts","ref":"changelog.html#v3-1-0-2018-07-30"},{"type":"extras","title":"v3.0.1 [2017-09-02] - Changelog","doc":"- [Fixed] Agent should be stopped too when `OPQ.stop/1` is called\n- [Improved] Varies small fixes and improvements","ref":"changelog.html#v3-0-1-2017-09-02"},{"type":"extras","title":"v3.0.0 [2017-08-31] - Changelog","doc":"- [Added] Added support for enqueueing MFAs\n- [Improved] Simplified named queue API by storing `opts`\n- [Improved] Varies small fixes and improvements","ref":"changelog.html#v3-0-0-2017-08-31"},{"type":"extras","title":"v2.0.1 [2017-08-30] - Changelog","doc":"- [Improved] Event dispatching should immediately be paused\n- [Improved] Varies small fixes and improvements","ref":"changelog.html#v2-0-1-2017-08-30"},{"type":"extras","title":"v2.0.0 [2017-08-29] - Changelog","doc":"- [Added] Pause / resume / stop the queue\n- [Improved] Varies small fixes and improvements","ref":"changelog.html#v2-0-0-2017-08-29"},{"type":"extras","title":"v1.0.1 [2017-08-14] - Changelog","doc":"- [Improved] Varies small fixes and improvements","ref":"changelog.html#v1-0-1-2017-08-14"},{"type":"extras","title":"v1.0.0 [2017-08-14] - Changelog","doc":"- [Added] A fast, in-memory FIFO queue\n- [Added] Worker pool\n- [Added] Rate limit\n- [Added] Timeouts\n- [Improved] Varies small fixes and improvements","ref":"changelog.html#v1-0-0-2017-08-14"},{"type":"extras","title":"Overview","doc":"# OPQ: One Pooled Queue\n\n[![Build Status](https://github.com/fredwu/opq/actions/workflows/ci.yml/badge.svg)](https://github.com/fredwu/opq/actions)\n[![CodeBeat](https://codebeat.co/badges/76916047-5b66-466d-91d3-7131a269899a)](https://codebeat.co/projects/github-com-fredwu-opq-master)\n[![Coverage](https://img.shields.io/coveralls/fredwu/opq.svg)](https://coveralls.io/github/fredwu/opq?branch=master)\n[![Hex Version](https://img.shields.io/hexpm/v/opq.svg)](https://hex.pm/packages/opq)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/opq/)\n[![Total Download](https://img.shields.io/hexpm/dt/opq.svg)](https://hex.pm/packages/opq)\n[![License](https://img.shields.io/hexpm/l/opq.svg)](https://github.com/fredwu/opq/blob/master/LICENSE.md)\n[![Last Updated](https://img.shields.io/github/last-commit/fredwu/opq.svg)](https://github.com/fredwu/opq/commits/master)","ref":"readme.html"},{"type":"extras","title":"Elixir Queue! - Overview","doc":"A simple, in-memory queue with worker pooling and rate limiting in Elixir. OPQ leverages Erlang's [queue](http://erlang.org/doc/man/queue.html) module and Elixir's [GenStage](https://github.com/elixir-lang/gen_stage).\n\nOriginally built to support [Crawler](https://github.com/fredwu/crawler).","ref":"readme.html#elixir-queue"},{"type":"extras","title":"Features - Overview","doc":"- A fast, in-memory FIFO queue.\n- Worker pool.\n- Rate limit.\n- Timeouts.\n- Pause / resume / stop the queue.\n\nSee [Hex documentation](https://hexdocs.pm/opq/).","ref":"readme.html#features"},{"type":"extras","title":"Installation - Overview","doc":"```Elixir\ndef deps do\n  [{:opq, \"~> 4.0\"}]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Overview","doc":"#","ref":"readme.html#usage"},{"type":"extras","title":"A simple example: - Overview","doc":"```elixir\n{:ok, opq} = OPQ.init()\n\nOPQ.enqueue(opq, fn -> IO.inspect(\"hello\") end)\nOPQ.enqueue(opq, fn -> IO.inspect(\"world\") end)\n```\n\n#","ref":"readme.html#a-simple-example"},{"type":"extras","title":"Specify module, function and arguments: - Overview","doc":"```elixir\n{:ok, opq} = OPQ.init()\n\nOPQ.enqueue(opq, IO, :inspect, [\"hello\"])\nOPQ.enqueue(opq, IO, :inspect, [\"world\"])\n```\n\n#","ref":"readme.html#specify-module-function-and-arguments"},{"type":"extras","title":"Specify a custom name for the queue: - Overview","doc":"```elixir\nOPQ.init(name: :items)\n\nOPQ.enqueue(:items, fn -> IO.inspect(\"hello\") end)\nOPQ.enqueue(:items, fn -> IO.inspect(\"world\") end)\n```\n\n#","ref":"readme.html#specify-a-custom-name-for-the-queue"},{"type":"extras","title":"Start as part of a supervision tree: - Overview","doc":"Note, when starting as part of a supervision tree, the `:name` option must be provided.\n\n```elixir\nchildren = [\n  {OPQ, name: :items}\n]\n```\n\n#","ref":"readme.html#start-as-part-of-a-supervision-tree"},{"type":"extras","title":"Specify a custom worker to process items in the queue: - Overview","doc":"```elixir\ndefmodule CustomWorker do\n  def start_link(item) do\n    Task.start_link(fn ->\n      Agent.update(:bucket, &[item | &1])\n    end)\n  end\nend\n\nAgent.start_link(fn -> [] end, name: :bucket)\n\n{:ok, opq} = OPQ.init(worker: CustomWorker)\n\nOPQ.enqueue(opq, \"hello\")\nOPQ.enqueue(opq, \"world\")\n\nAgent.get(:bucket, & &1) # => [\"world\", \"hello\"]\n```\n\n#","ref":"readme.html#specify-a-custom-worker-to-process-items-in-the-queue"},{"type":"extras","title":"Rate limit: - Overview","doc":"```elixir\n{:ok, opq} = OPQ.init(workers: 1, interval: 1000)\n\nTask.async(fn ->\n  OPQ.enqueue(opq, fn -> IO.inspect(\"hello\") end)\n  OPQ.enqueue(opq, fn -> IO.inspect(\"world\") end)\nend)\n```\n\nIf no interval is supplied, the ratelimiter will be bypassed.\n\n#","ref":"readme.html#rate-limit"},{"type":"extras","title":"Check the queue and number of available workers: - Overview","doc":"```elixir\n{:ok, opq} = OPQ.init()\n\nOPQ.enqueue(opq, fn -> Process.sleep(1000) end)\n\n{status, queue, available_workers} = OPQ.info(opq) # => {:normal, #OPQ.Queue , 9}\n\nProcess.sleep(1200)\n\n{status, queue, available_workers} = OPQ.info(opq) # => {:normal, #OPQ.Queue , 10}\n```\n\nIf you just need to get the queue itself:\n\n```elixir\nOPQ.queue(opq) # => #OPQ.Queue \n```\n\n#","ref":"readme.html#check-the-queue-and-number-of-available-workers"},{"type":"extras","title":"Queue - Overview","doc":"OPQ implements `Enumerable`, so you can perform enumerable functions on the queue:\n\n```elixir\n{:ok, opq} = OPQ.init()\n\nqueue = OPQ.queue(opq)\n\nEnum.count(queue) # => 0\nEnum.empty?(queue) # => true\n```\n\n#","ref":"readme.html#queue"},{"type":"extras","title":"Stop the queue: - Overview","doc":"```elixir\n{:ok, opq} = OPQ.init()\n\nOPQ.enqueue(opq, fn -> IO.inspect(\"hello\") end)\nOPQ.stop(opq)\nOPQ.enqueue(opq, fn -> IO.inspect(\"world\") end) # => (EXIT) no process...\n```\n\n#","ref":"readme.html#stop-the-queue"},{"type":"extras","title":"Pause and resume the queue: - Overview","doc":"```elixir\n{:ok, opq} = OPQ.init()\n\nOPQ.enqueue(opq, fn -> IO.inspect(\"hello\") end) # => \"hello\"\nOPQ.pause(opq)\nOPQ.info(opq) # => {:paused, {[], []}, 10}\nOPQ.enqueue(opq, fn -> IO.inspect(\"world\") end)\nOPQ.resume(opq) # => \"world\"\nOPQ.info(opq) # => {:normal, {[], []}, 10}\n```","ref":"readme.html#pause-and-resume-the-queue"},{"type":"extras","title":"Configurations - Overview","doc":"| Option       | Type        | Default Value  | Description |\n|--------------|-------------|----------------|-------------|\n| `:name`      | atom/module | pid            | The name of the queue.\n| `:worker`    | module      | `OPQ.Worker`   | The worker that processes each item from the queue.\n| `:workers`   | integer     | `10`           | Maximum number of workers.\n| `:interval`  | integer     | `0`            | Rate limit control - number of milliseconds before asking for more items to process, defaults to `0` which is effectively no rate limit.\n| `:timeout`   | integer     | `5000`         | Number of milliseconds allowed to perform the work, it should always be set to higher than `:interval`.","ref":"readme.html#configurations"},{"type":"extras","title":"Changelog - Overview","doc":"Please see [CHANGELOG.md](CHANGELOG.md).","ref":"readme.html#changelog"},{"type":"extras","title":"License - Overview","doc":"Licensed under [MIT](http://fredwu.mit-license.org/).","ref":"readme.html#license"}],"content_type":"text/markdown"}